/*
  slam3 (c) 2006 Kris Beevers

  This file is part of slam3.

  slam3 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  slam3 is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with slam3; if not, write to the Free Software Foundation,
  Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

// minimum mahalanobis distance data association

#include "slam.hpp"

void data_association
  (const feature_type &f,
   const std::vector<map_type::iterator> &in_range,
   map_type::iterator &assoc, double &mahalanobis_dist)
{
  assert(in_range.size() != 0);

  double m;
  assoc = in_range[0];
  mahalanobis_dist = mahalanobis_distance(in_range[0]->landmark, f);
  //mahalanobis_dist = distance(in_range[0]->landmark,f);
  for(uint32_t i = 1; i < in_range.size(); ++i) {
    if(!overlap(in_range[i]->landmark, f))
      continue;
    m = mahalanobis_distance(in_range[i]->landmark, f);
    //m = distance(in_range[0]->landmark,f);
    if(m < mahalanobis_dist) {
      assoc = in_range[i];
      mahalanobis_dist = m;
    }
  }
}
